%global momorel 2

%global jpver		j1.34
%global texmf		%{_datadir}/texmf
%global texmfvar	%{_datadir}/texmf-var
#%global mapdir          %{texmf}/fonts/map/dvipdfm
%global x11dir          %{_datadir}/X11

%global e_sitedir       %{_datadir}/emacs/site-lisp
%global xe_sitedir      %{_datadir}/xemacs/site-lisp
%global sitepdir        %{_datadir}/xemacs/site-packages
%global confsample_dir  %{_datadir}/config-sample

%global exec_texhash	[ -x %{_bindir}/texhash ] && %{_bindir}/env - %{_bindir}/texhash 2> /dev/null
%global exec_updmap     [ -x %{_bindir}/updmap-sys ] && %{_bindir}/env - %{_bindir}/updmap-sys 

Summary: A DVI viewer for X Window System.
Name:    xdvik
Version: 22.84.10
Release: %{momorel}m

### include local configuration
%{?include_specopt}
%{?!gothicfont:  %global gothicfont  ipag.ttf}
%{?!minchofont:  %global minchofont  ipam.ttf}

License: GPL
Group: Applications/Publishing
URL: http://xdvi.sourceforge.net/
%NoSource 0 http://dl.sourceforge.net/sourceforge/xdvi/xdvik-%{version}.tar.gz 31a01ea9be9ab581c2f23a0c914a2b36
Source1: XDvi.momonga
#Source2: vfontmap.momonga
Source3: xdvi.desktop
Source4: dot.emacs.xdvik
# patches from xdvik-jp project
Patch1: http://prdownloads.sourceforge.jp/xdvi/00000/xdvik-22.84.10-%{jpver}.patch.gz
# Patch2 is imported from Vine
Patch2: xdvik-config.mo.diff
Patch3: xdvik-22.40w-xorg7-needwideprototypes.patch
Requires: tetex, freetype2
Requires: truetype-fonts-ja-ipa
Requires: openmotif, Xaw3d
BuildRequires: libX11-devel
BuildRequires: libXp-devel, libXmu-devel, libXt-devel, libXdmcp-devel
BuildRequires: libXdmcp-devel, libSM-devel, libICE-devel, libXext-devel
BuildRequires: openmotif-devel, Xaw3d-devel
BuildRequires: kpathsea-devel >= 3.5.4, freetype2-devel
BuildRequires: desktop-file-utils
PreReq: tetex >= 3.0, chkconfig
Requires(post): kpathsea, tetex, tetex-dvipsk
Requires(postun): kpathsea, tetex, tetex-dvipsk
Requires: kpathsea, tetex, tetex-dvipsk
#PreReq: dvipdfmx >= 20050831
Provides: tetex-xdvi, tetex-xdvik
Buildroot: %{_tmppath}/%{name}-%{version}-root

%description
Xdvik is a program for displaying DVI files (generated e.g. by Troff
or TeX) on the X window system. It is based on the regular (non-k)
xdvi of the same version number.

%package emacs
Summary: xdvi inverse search with emacs
Group: Applications/Engineering
Requires: emacs
Requires: %{name} = %{version}-%{release}

%description emacs
Emacs interface for xdvi inverse search with emacs

Inverse search means that

    * A mouse click (Ctrl-Button1 by default) in the xdvi window can open an editor with the corresponding place in the (La)TeX source (also called `reverse search'), and
    * xdvi can jump to (and visually highlight) a position in the DVI file that corresponds to a certain line number in the (La)TeX source file (`forward search'). 

This functionality is supported by xdvi(k) versions 22.38 and upwards. It uses so-called `source specials' in the DVI file, which can be inserted via a macro package or a command-line option to the (La)TeX program (executable). 

%package xemacs
Summary: xdvi inverse search with xemacs
Group: Applications/Engineering
Requires: xemacs
Requires: %{name} = %{version}-%{release}

%description xemacs
Emacs interface for xdvi inverse search with emacs

Inverse search means that

    * A mouse click (Ctrl-Button1 by default) in the xdvi window can open an editor with the corresponding place in the (La)TeX source (also called `reverse search'), and
    * xdvi can jump to (and visually highlight) a position in the DVI file that corresponds to a certain line number in the (La)TeX source file (`forward search'). 

This functionality is supported by xdvi(k) versions 22.38 and upwards. It uses so-called `source specials' in the DVI file, which can be inserted via a macro package or a command-line option to the (La)TeX program (executable). 


%prep
%setup -q -n %{name}-%{version}
#%patch0 -p1
%patch1 -p1
(cd texk/xdvik
%patch2 -p0
)
%patch3 -p1 -b .wide

%build

%ifarch sparc
EXT_LIB="-lXext"
%endif

# build motif version
CFLAGS="$RPM_OPT_FLAGS -DA4" ./configure \
	--prefix=\${DESTDIR}%{_prefix} \
	--bindir=\${DESTDIR}%{_bindir} --mandir=\${DESTDIR}%{_mandir} \
	--datadir=\${DESTDIR}%{_datadir} \
	--enable-shared --with-dvifilter=dvips \
	--enable-freetype --with-vfontmap --enable-bdpi=600 \
	--enable-xdviprint=\${DESTDIR}%{_bindir}/xdviprint \
	--enable-xdvietcdir=\${DESTDIR}/usr/share/texmf/xdvi \
	--enable-shrink=7  --enable-smallpanel \
	--with-xdvi-x-toolkit=motif --with-system-www
make x_ext_lib="$EXT_LIB"

%install
rm -rf %{buildroot}
make DESTDIR=%{buildroot} texmf=%{buildroot}%{texmf} install
mv %{buildroot}%{_bindir}/xdvi %{buildroot}%{_bindir}/xdvi-motif.sh
mv %{buildroot}%{_bindir}/oxdvi %{buildroot}%{_bindir}/oxdvi-motif.sh
mv %{buildroot}%{_bindir}/xdvizilla %{buildroot}%{_bindir}/xdvizilla-motif.sh

# build and install Xaw3d version
make clean
CFLAGS="$RPM_OPT_FLAGS -DA4" ./configure \
	--prefix=\${DESTDIR}%{_prefix} \
	--bindir=\${DESTDIR}%{_bindir} --mandir=\${DESTDIR}%{_mandir} \
	--datadir=\${DESTDIR}%{_datadir} \
	--enable-shared --with-dvifilter=dvips \
	--enable-freetype --with-vfontmap --enable-bdpi=600 \
	--enable-xdviprint=\${DESTDIR}%{_bindir}/xdviprint \
	--enable-xdvietcdir=\${DESTDIR}/usr/share/texmf/xdvi \
	--enable-shrink=7  --enable-smallpanel \
	--with-xdvi-x-toolkit=xaw3d --with-system-www
make DESTDIR=%{buildroot} texmf=%{buildroot}/%{texmf} install-exec
mv %{buildroot}%{_bindir}/xdvi %{buildroot}%{_bindir}/xdvi-xaw3d.sh
mv %{buildroot}%{_bindir}/oxdvi %{buildroot}%{_bindir}/oxdvi-xaw3d.sh
mv %{buildroot}%{_bindir}/xdvizilla %{buildroot}%{_bindir}/xdvizilla-xaw3d.sh
# for alternatives
touch %{buildroot}%{_bindir}/xdvi
touch %{buildroot}%{_bindir}/oxdvi
touch %{buildroot}%{_bindir}/xdvizilla

install -d %{buildroot}%{texmf}/fonts/map/xdvi
cp -a texk/xdvik/texmf-alt/*.map %{buildroot}%{texmf}/fonts/map/xdvi

# icons
install -d %{buildroot}%{_datadir}/pixmaps
for icon in xdvi16x16.xpm xdvi32x32.xpm xdvi48x48.xpm
do
install -m 644 texk/xdvik/pixmaps/$icon %{buildroot}%{_datadir}/pixmaps
done

# desktop file
install -d %{buildroot}%{_datadir}/applications
desktop-file-install --vendor= \
  --dir %{buildroot}%{_datadir}/applications \
  --add-category Application \
    --add-category Graphics \
    %{SOURCE3}

# emacs
install -d %{buildroot}%{e_sitedir}
cp -f texk/xdvik/xdvi-search.el %{buildroot}%{e_sitedir}
# xemacs
install -d %{buildroot}%{sitepdir}/lisp
cp -f texk/xdvik/xdvi-search.el %{buildroot}%{sitepdir}/lisp

## CHANGES: now create vfontmap dynamically using updmap-sys at %%post
##
## set up vfontmap
#cat <<EOF > %{buildroot}%{texmf}/xdvi/vfontmap || exit
#%
#% vfontmap -- Do NOT edit this file BY HAND!!
#
#% [single style]
#% "tfm" "enc" "font"
#
#% [multi style]
#% "/font/file/name"
#%    "tfm1" "enc"
#%    "tfm2" "enc"
#
#% "enc" is one of following.
#% "JIS-H" "Unicode-H" "Identity-H"
#% "JIS-V" "Unicode-V" "Identity-V"
#
#
#%{x11dir}/fonts/truetype-ja/sazanami-mincho.ttf
#        rml  JIS-H
#        rmlv JIS-V
#
#%{x11dir}/fonts/truetype-ja/sazanami-gothic.ttf
#        gbm  JIS-H
#        gbmv JIS-V
#EOF

mkdir -p %{buildroot}%{texmfvar}/fonts/map/xdvi/updmap
## vfontmap are created by updmap-sys at %%post
## Since updmap is executed at the time tetex-* are installed, vfontmap
## is made by tetex. Then tetex should own vfontmap
#install -m 644 %{SOURCE2} %{buildroot}%{texmfvar}/fonts/map/xdvi/updmap/vfontmap

# resource file
install -d %{buildroot}/%{x11dir}/ja/app-defaults
install -m 644 %{SOURCE1} %{buildroot}%{texmf}/xdvi/XDvi
ln -sf ../../../texmf/xdvi/XDvi %{buildroot}/%{x11dir}/ja/app-defaults/XDvi

# config sample
mkdir -p %{buildroot}%{_datadir}/config-sample/xdvik
install -m 644 %{SOURCE4} %{buildroot}%{_datadir}/config-sample/xdvik

rm -rf %{buildroot}/usr/share/texmf/release-tetex-src.txt

%post
# alternatives
/usr/sbin/update-alternatives --install %{_bindir}/xdvi      xdvi      %{_bindir}/xdvi-xaw3d.sh  15 \
                                --slave %{_bindir}/oxdvi     oxdvi     %{_bindir}/oxdvi-xaw3d.sh \
                                --slave %{_bindir}/xdvizilla xdvizilla %{_bindir}/xdvizilla-xaw3d.sh
/usr/sbin/update-alternatives --install %{_bindir}/xdvi.bin  xdvi.bin  %{_bindir}/xdvi-xaw3d.bin 15

/usr/sbin/update-alternatives --install %{_bindir}/xdvi      xdvi      %{_bindir}/xdvi-motif.sh 20 \
                                --slave %{_bindir}/oxdvi     oxdvi     %{_bindir}/oxdvi-motif.sh \
                                --slave %{_bindir}/xdvizilla xdvizilla %{_bindir}/xdvizilla-motif.sh
/usr/sbin/update-alternatives --install %{_bindir}/xdvi.bin  xdvi.bin  %{_bindir}/xdvi-motif.sh 20

# ls-R
%{exec_texhash}
# font setting for /usr/share/texmf/web2c/updmap.cfg
%{exec_updmap} --quiet --nomkmap --setoption xdviGbm %{gothicfont} 2> /dev/null
%{exec_updmap} --quiet --nomkmap --setoption xdviRml %{minchofont} 2> /dev/null
# make and update vfontmap
%{exec_updmap} --quiet 2> /dev/null

%postun
if [ "$1" = 0 ]; then
# alternatives
 /usr/sbin/update-alternatives --remove xdvi %{_bindir}/xdvi-xaw3d.sh
 /usr/sbin/update-alternatives --remove xdvi %{_bindir}/xdvi-motif.sh
fi
# ls-R
%{exec_texhash}

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)
%doc CHANGES INSTALL README* TODO
%doc texk/xdvik/{BUGS,CHANGES*,FAQ,README*}
%doc texk/xdvik/READMEs/
%ghost %{_bindir}/xdvi
%ghost %{_bindir}/oxdvi
%ghost %{_bindir}/xdvizilla
%{_bindir}/xdvi-*
%{_bindir}/xdvizilla*
%{_bindir}/oxdvi-*
%{_mandir}/man1/*
%dir %{texmf}/xdvi
# owned by tetex-common 
# (since updmap-sys makes vofntmap even if xdvik is not installed)
#%dir %{texmfvar}/fonts/map/xdvi/updmap
#%config %{texmfvar}/fonts/map/xdvi/updmap/vfontmap
%config %{texmf}/xdvi/*.cfg
%{texmf}/fonts/map/xdvi/*.map
%{texmf}/xdvi/vfontmap.*
%{texmf}/xdvi/pixmaps
%{texmf}/xdvi/XDvi
%{x11dir}/ja/app-defaults/XDvi
%{_datadir}/pixmaps/*
%{_datadir}/applications/*.desktop

%files emacs
%defattr(-,root,root)
%{e_sitedir}/*
%{_datadir}/config-sample/xdvik

%files xemacs
%defattr(-,root,root)
%{sitepdir}/lisp/*

%changelog
* Wed Jun 28 2006 Mitsuru Shimamura <smbd@momonga-linux.org>
- (22.84.10-2m)
- now IPAPGothic/Mincho is default font
- correct alternative install

* Wed Jun 14 2006 Masayuki SANO <nosanosa@momonga-linux.org>
- (22.84.10-1m)
- update to 22.84.10 with tetex-3.0
- japanese patche is updated to xdvik-22.84.10-j1.34.patch.gz
- [ Font ]
- adopted specopt to change truetype fonts for Gothic and Mincho in Japanese.
- - default fonts are set to "sazanami-gothic.ttf" and "sazanami-mincho.ttf"
- - font setting (vfontmap editting) is done in postinstall script using extended  (ptetex version) updmap-sys which is in tetex-common.
- [ Widget ]
- built both of Motif and Xaw3d version and adopted alternatives to switch them (Default is Motif. But Xaw3d is superior in one point that it is possible to input Japanese in "string search dialog" using XIM. In motif version, use "cut and paste" to input Japanese)
- - default X11 resource XDvi are imported from ptetex and modified for Momonga
- - Xaw3d version is colorized by the way from http://phe.phyas.aichi-edu.ac.jp/~cyamauch/3d_w.html
- [ Inverse search ]
- inverse search using emacs or xemacs are possible by xdvik-emacs or xdvik-xemacs (use sample .emacs in %%{_datadir}/config-sample)

* Mon Apr 03 2006 Masayuki SANO <nosanosa@momonga-linux.org>
- (22.84.10-0m)
- test 22.84.10 with tetex-2.0.2 (based on vine package 22.84.10-0vl4)
- changelog of Vine package
- - * Thu Nov 17 2005 KOBAYASHI Taizo <tkoba@vinelinux.org> 22.84.10-0vl4
- - modified post section: added font setting
- * Thu Nov 10 2005 KOBAYASHI Taizo <tkoba@vinelinux.org> 22.84.10-0vl3
- - added PreReq dvipdfmx >= 20050831
- * Sun Nov 06 2005 KOBAYASHI Taizo <tkoba@vinelinux.org> 22.84.10-0vl2
- - fixed truetype fonts search name
- * Sun Nov 06 2005 KOBAYASHI Taizo <tkoba@vinelinux.org> 22.84.10-0vl1
- - resync with ptetex3-20051102
- * Wed Aug 31 2005 KOBAYASHI Taizo <tkoba@vinelinux.org> 22.84.10-0vl0.2
- - resync with ptetex3-20050830
- * Sat Jun 18 2005 KOBAYASHI Taizo <tkoba@vinelinux.org> 22.84.10-0vl0.1
- - source update
- - modified for teTeX3

* Mon Apr 03 2006 Masayuki SANO <nosanosa@momonga-linux.org>
- (22.40w-6m)
- add xdvik-22.40w-xorg7-needwideprottypes.patch
- - Since xorg-7.0, NeedWidePrototypes in X11/Xfuncproto.h has been undefined by default. However xdvi needs to be built with NeedWidePrototypes to display Japanese. Then we defined it in texk/xdvi/xdvi.h

* Thu Jul  1 2004 Kazuhiko <kazuhiko@fdiary.net>
- (22.40w-5m)
- revise vfontmap.momonga for sazanami fonts [Momonga-devel.ja:02609]

* Sat Jun 12 2004 Masahiro Takahata <takahata@momonga-linux.org>
- (22.40w-4m)
- add Requires: w3c-libwww

* Sun Jul  6 2003 Kazuhiko <kazuhiko@fdiary.net>
- (22.40w-3m)
- Provides tetex-xdvi for update

* Sat Jul  5 2003 Kenta MURATA <muraken2@nifty.com>
- (22.40w-2m)
- PreReq: kpathsea.

* Sat Jul  5 2003 Kenta MURATA <muraken2@nifty.com>
- (22.40w-1m)
- version 22.40w.
- split from tetex.spec.
